// NtalkbizBat.cpp :  α׷   մϴ.
//

#include "stdafx.h"
#include "NtalkbizBat.h"
#include "corevalueregistryconst.h"
#include "Registry.h"

#include "ProcessClear.h"


#define MAX_LOADSTRING 100
#define SERVICE_APP_NAME	_T("NtalkbizUpgrader")
#ifdef _DEBUG
#define SERVICE_APP_EXE		_T("NtalkbizUpgraderD.exe")
#else
#define SERVICE_APP_EXE		_T("NtalkbizUpgrader.exe")
#endif


//  :
HINSTANCE hInst;								//  νϽԴϴ.
TCHAR szTitle[MAX_LOADSTRING];					//  ǥ ؽƮԴϴ.
TCHAR szWindowClass[MAX_LOADSTRING];			// ⺻ â Ŭ ̸Դϴ.



CString g_strRootPath;




int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	g_strRootPath = Registry::ReadString(HKEY_CURRENT_USER, REGVAL_ROOTPATH, _T("Path"));
	
	if(_tcsicmp(lpCmdLine, _T("-install")) == 0)
	{
		InstallService();
	}
	else if(_tcsicmp(lpCmdLine, _T("-stop")) == 0)
	{
		UnInstallService();
	}
	else if(_tcsicmp(lpCmdLine, _T("-clear")) == 0)
	{
		ProcessClear();
	}


	return 1;
}

void InstallService()
{
	SC_HANDLE hServiceManager = NULL;
	SC_HANDLE hService = NULL;

	//  Ŵ 
	hServiceManager = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(hServiceManager == NULL)
	{		
		_ASSERT(FALSE);		
		return;
	}

	CString strServiceAppPath;
	strServiceAppPath.Format(_T("%s\\%s"), g_strRootPath, SERVICE_APP_EXE);

	//  
	hService = ::CreateService(hServiceManager, 
								SERVICE_APP_NAME, 
								SERVICE_APP_NAME, 
								SERVICE_ALL_ACCESS, 
								SERVICE_WIN32_OWN_PROCESS, 
								SERVICE_AUTO_START, 
								SERVICE_ERROR_NORMAL, 
								strServiceAppPath, 
								NULL, 
								NULL, 
								NULL, 
								NULL, 
								NULL);
	if(hService == NULL)
	{
		DWORD dwErr = GetLastError();
		if(dwErr == ERROR_SERVICE_EXISTS || dwErr == ERROR_DUP_NAME)
		{
			//񽺰 Ǵ  ̸ 񽺰 ̹ ϴ°
			return;
		}
		else
		{
			::CloseServiceHandle(hServiceManager);
			_ASSERT(FALSE);
			return;
		}		
	}
	else
	{
		//  
		SERVICE_DESCRIPTION serviceDesc;
		serviceDesc.lpDescription = _T("Ntalk biz Ʈ ϱ  α׷Դϴ.");
		::ChangeServiceConfig2(hService, SERVICE_CONFIG_DESCRIPTION, &serviceDesc);

		::StartService(hService, 0, NULL);
	}

	::CloseServiceHandle(hService);
	::CloseServiceHandle(hServiceManager);

}

void UnInstallService()
{
	SERVICE_STATUS serviceStatus;
	SC_HANDLE hServiceManager = NULL;
	SC_HANDLE hService = NULL;

	//  Ŵ 
	hServiceManager = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(hServiceManager == NULL)
	{		
		_ASSERT(FALSE);
		return;
	}

	// ϵǾ ִ 񽺸 
	hService = ::OpenService(hServiceManager, SERVICE_APP_NAME, SERVICE_ALL_ACCESS);
	if(hService == NULL)
	{
		CloseServiceHandle(hServiceManager);
		_ASSERT(FALSE);
		return;
	}

	//  
	::QueryServiceStatus(hService, &serviceStatus);
	if(serviceStatus.dwCurrentState != SERVICE_STOP)
	{
		::ControlService(hService, SERVICE_CONTROL_STOP, &serviceStatus);
		::Sleep(1000);
	}


	// 
	BOOL bDel = ::DeleteService(hService);
	if(bDel == FALSE)
	{
		::CloseServiceHandle(hService);
		::CloseServiceHandle(hServiceManager);
		_ASSERT(FALSE);
		return;
	}

	::CloseServiceHandle(hService);
	::CloseServiceHandle(hServiceManager);

}

void ProcessClear()
{
	CProcessClear clear;
	BOOL bClear = clear.Clear();

}


